/*****************************************************************
* The software in this file was written by Jessica Gaines,       *
* while working at the University of Edinburgh, under the        *
* direction of Terry Lyons, and using funding                    *
* provided by EC grant SC1*CT92-0784.                            *
* You may use this software for educational and academic         *
* research purposes only.                                        *
* Please do not give copies of the software in this file to      *
* anyone else. Tell anyone interested to email                   *
*  jessica@maths.ed.ac.uk                                        *
* or to write to                                                 *
*  Jessica Gaines                                                *
*  University of Edinburgh                                       *
*  Dept. of Mathematics and Statistics                           *
*  JCMB                                                          *
*  Kings Buildings                                               *
*  Mayfield Road                                                 *
*  Edinburgh EH9 3JZ                                             *
*  UK                                                            *
* and then get copies directly from Edinburgh themselves.        *
******************************************************************
*/
 
/* Program used for generation of a brownian path
 * by calling routine brown3 (in brown.c). The resulting path
 * is stored in a file (whose name must be given
 * as an argument to the program), and is ready
 * to be used during the solution of an sde using
 * fixed or variable step size. The path may be read and
 * added to during the solution by the routine getdw (in brown.c).
*/

#include <stdio.h>
#include <math.h>

typedef struct{ int recno,level,prerec,nexrec,parent;
                int lson,rson,spare[7];
                float t0,tp;} record;
typedef struct{ int np,nw,nlevels,nl1,seed,nrecs1,nrecs2;
                int spare[7];
                float sp[2];} header;
FILE *in;
char *wfile;

main(argc,argv) int argc; char **argv;
{
float ran3(),t,T; int nw,nl,n1,np,seed=(-992);
if(argc!=2) 
 {printf(" Must supply name of file to store points.\n");
  exit(1);}
getint(&nw,"no. of brownian paths");
getint(&np,"no. of elements in each array (512/no. of paths is recommended)");
getint(&nl,"n, where minimum required time step is 2^-n"); nl++;
getint(&n1,"n, where maximum required time step is 2^-n"); 
/* This argument is not really used. It is included so that the
   questions asked are the same and in the same order as the questions
   asked by brown6. (Then the 2 programs can read data from the same
   file.)
 */

getfloat(&T,"final time");

n1=2; t=0.5*np;
while(t>=T) {n1++; t*=0.5;}
if(n1>nl) n1=nl;
/* printf(" No. incomplete levels = %d\n",n1); */
do getint(&seed,"seed (negative)");
 while (seed>-1);
ran3(seed);
brown3(nl,n1,np,nw,ran3,seed,argv[1]);
}
     

